class Cedge : public Cobject {
public:
	static Cedge 		*g_hash[HASHSIZE];
	static unsigned int	 g_hash_cnt;

	Cedge			*m_hashP;
	Cfile			*m_fileP;
	int				m_lineno;
	Centity			*m_fromP;	/* Variable->function						*/
	Cclassmember	*m_toP;		/* Function->function or Function->variable */
	unsigned int	m_freq;
	int				m_flags;

#define UpdateX 0x01

	static unsigned int hash(const Centity *fromP, const Cclassmember *toP);
	Cedge(Centity *fromP, Cclassmember *toP, int lineno, Cfile *fileP);
	static Cedge *	locate(Centity *fromP, Cclassmember *toP, int lineno, Cfile *fileP);

	const char *	get_type(void) const;

	virtual objectE	type(void) const;
	virtual void	emit_id(void) const;
	virtual void	print(void) const;
	virtual void	emit_edges(void);

	void			emit_attributes(void) const;
};
